﻿<AML>
 <Item type="Method" id="2966D37D8F224E6F8F08A488D9F4F5E8" action="add">
  <execution_allowed_to keyed_name="World" type="Identity">A73B655731924CD0B027E4F4D5FCC0A9</execution_allowed_to>
  <method_code><![CDATA[            /* *****************************************************************************
            Method Name:			sop_Import_SaleOrderExcel
            Created By/Company:		Sandar 
            Creation Date:			2019-06-11
            Description:
                Read from the excel file

            Hooks:
                Type:		sop_sale_order
                Event:		called from client method
                Called by:	sop_so_excelfile_import

            Inputs:
                <describe the inputs expected by the server method>

            Revisions:
                Rev Date		Modified By			Description
                YYYY-MM-DD		***					Initial creation
            ***************************************************************************** */

            //WARNING: DO NOT FORGET TO DISABLE THIS IN A PRODUCTION ENVIRONMENT!!!
            // if (System.Diagnostics.Debugger.Launch()) System.Diagnostics.Debugger.Break();

            string MethodName = "sop_Import_SaleOrderExcel";

            //***** GRANT IDENTITY PRIVILEGES
            // grantIdentityPrivileges("Super User"); // If this is enabled always revoke the privileges in the Finally below.
            //*******************************
            Innovator myInnovator = this.getInnovator();
            Item result = this; // default return value.
            Microsoft.Office.Interop.Excel.Application excelApp = null;

            try
            {
                string headerID = "";
                Item saleOrderHeader = null;
                Item saleOrderSectionDetail = null;
                string currency = this.getProperty("pop_currency");

                string getid = this.getID();
                string location = this.getProperty("location");
                string addfilePath = this.getProperty("filepath");
                string fileName = System.IO.Path.GetFileName(addfilePath);
                fileName = this.getProperty("fileName");
                string excel_format_list = this.getProperty("excel_format_list", "");
                string import_type = this.getProperty("import_type", "");

                string userID = myInnovator.getUserID();
                string defaultvault = System.Web.HttpContext.Current.Server.MapPath("temp");
                string fileID = this.getProperty("fileid");
                string filePath = CheckOutFile(myInnovator, fileID, defaultvault, fileName);

                DataTable dt = new DataTable();
                /*create the Application object we can use in the member functions.*/
                excelApp = new Microsoft.Office.Interop.Excel.Application();

                Microsoft.Office.Interop.Excel.Workbook workbook = excelApp.Workbooks.Open(filePath,
                    Type.Missing, Type.Missing, Type.Missing, Type.Missing,
                    Type.Missing, Type.Missing, Type.Missing, Type.Missing,
                    Type.Missing, Type.Missing, Type.Missing, Type.Missing,
                    Type.Missing, Type.Missing);

                /**select the first sheet */
                Microsoft.Office.Interop.Excel.Worksheet worksheet = (Microsoft.Office.Interop.Excel.Worksheet)workbook.Worksheets[1];

                /** find the used range in worksheet*/
                Microsoft.Office.Interop.Excel.Range excelRange = (Microsoft.Office.Interop.Excel.Range)worksheet.UsedRange;

                //get an object array of all of the cells in the worksheet (their values)
                object[,] valueArray = (object[,])excelRange.get_Value(Microsoft.Office.Interop.Excel.XlRangeValueDataType.xlRangeValueDefault);

                DataRow data_row = null;
                DataRow old_data_row = null;
                for (int columns = 1; columns <= worksheet.UsedRange.Columns.Count; ++columns)
                {
                    dt.Columns.Add();
                }

                for (int row = 1; row <= worksheet.UsedRange.Rows.Count; ++row)
                {
                    data_row = dt.NewRow();
                    for (int columns = 1; columns <= worksheet.UsedRange.Columns.Count; ++columns)
                    {
                        //dt.Columns.Add();
                        if (valueArray[row, columns] != null)
                        {
                            var value = valueArray[row, columns].ToString();
                            data_row["Column" + columns] += valueArray[row, columns].ToString();
                        }
                    }
                    if (data_row != null && old_data_row != data_row)
                    {
                        dt.Rows.Add(data_row);
                        old_data_row = data_row;
                    }
                }

                int detail_row = 0;
                int detail_column = 0;
                int rowsCount = dt.Rows.Count - 1;
                bool START_OF_DETAILS = false;
                bool END_OF_DETAILS = false;
                int existing_data_column_count = 0;
                int old_existing_data_column_count = 0;
                int detail_column_count = 0;

                /* Declaration For Header*/
                string quoteNo = "";
                double subTotal = 0.00;
                string soNo = "";
                string company = "";
                string attentionTo = "";
                string customerRef = "";
                string quoteBy = "";
                string revNo = "";
                string address = "";
                string sgpWefic = "";
                string drawingNo = "";
                string tpiRequired = "";
                string tpiRequired_1 = "";
                string tpiRequired_2 = "";
                string tpiRequired_3 = "";
                string fatRequired = "";
                string proposedPaint = "";
                string prices = "";
                string delivery_term = "";
                string delivery = "";
                bool END_OF_DELIVERY = false;

                int stk_row_number = 0;
                int assembly_no = 0;
                int sub_assembly_no = 0;
                string assembly_desc = "";
                string sub_assembly_desc = "";
                string sub_assembly_total = "";

                string sop_total_line_1 = "";
                string sop_total_line_1_value = "";
                string sop_total_line_2 = "";
                string sop_total_line_2_value = "";
                string sop_total_line_3 = "";
                string sop_total_line_3_value = "";
                string date = "";

                /* End */

                /* Customer Ref*/
                string strCustomerRef = "";
                string strtpiRequired = "";
                string strproposedPaint = "";
                string strFatRequired = "";

                /*Declaration For Detail Data */
                string item = "";
                int sub_assembly_item = 1;
                string qty = "";
                string keurpn = "";
                string description = "";
                string unitprice = "0";
                string totalprice = "0";

                string details_desc_1 = "";
                string old_sub_assembly_desc = "";
                string sub_assembly_total_label = "";
                string sub_assembly_total_amount = "";
                string sub_assembly_qty = "";
                string sectionDetailID = "";
                string relationshipID = "";
                string relatedID = "";
                var count = 0;

                for (int row = 1; row <= dt.Rows.Count - 1; ++row)
                {
                    for (int columns = 1; columns < 7; ++columns)
                    {
                        if (row > rowsCount) return saleOrderHeader;

                        /** <For Item Detail> **/

                        if (row < rowsCount && dt.Rows[row][columns] != null)
                        {
                            /*Data For Header*/

                            if (dt.Rows[row][columns].ToString().Trim().ToUpper().StartsWith("QUOTE NO"))
                            {
                                if (dt.Rows[row][columns + 1] != null)
                                {
                                    quoteNo = dt.Rows[row][columns + 1].ToString();
                                }
                            }
                            if (dt.Rows[row][columns].ToString().Trim().ToUpper().StartsWith("COMPANY"))
                            {
                                if (dt.Rows[row][columns + 1] != null)
                                {
                                    company = dt.Rows[row][columns + 1].ToString();
                                }
                            }

                            if (dt.Rows[row][columns].ToString().Trim().ToUpper().StartsWith("ADDRESS"))
                            {
                                if (dt.Rows[row][columns + 1] != null)
                                {
                                    address = dt.Rows[row][columns + 1].ToString();
                                }
                            }

                            if (dt.Rows[row][columns].ToString().Trim().ToUpper().StartsWith("ATTENTION TO"))
                            {
                                if (dt.Rows[row][columns + 1] != null)
                                {
                                    attentionTo = dt.Rows[row][columns + 1].ToString();
                                }
                            }

                            if (dt.Rows[row][columns].ToString().Trim().ToUpper().StartsWith("CUSTOMER REF"))
                            {

                                if (dt.Rows[row][columns + 1] != null)
                                {
                                    customerRef = dt.Rows[row][columns + 1].ToString();
                                }

                                if (dt.Rows[row][columns + 1] == null)
                                {
                                    customerRef = dt.Rows[row][columns].ToString();
                                }
                            }

                            if (dt.Rows[row][columns].ToString().Trim().ToUpper().StartsWith("QUOTE BY"))
                            {
                                if (dt.Rows[row][columns + 1] != null)
                                {
                                    quoteBy = dt.Rows[row][columns + 1].ToString();
                                }
                            }

                            if (dt.Rows[row][columns].ToString().Trim().ToUpper().StartsWith("REV. NO"))
                            {
                                if (dt.Rows[row][columns + 1] != null)
                                {
                                    revNo = dt.Rows[row][columns + 1].ToString();
                                }
                            }
                            if (dt.Rows[row][columns].ToString().Trim().ToUpper().StartsWith("DATE"))
                            {
                                if (dt.Rows[row][columns + 1] != null)
                                {
                                    //date = ((DateTime)dt.Rows[row][columns + 1]).ToString("yyyy-MM-ddThh:mm:ss");
                                    date = dt.Rows[row][columns + 1].ToString();
                                    DateTime dateTime = Convert.ToDateTime(date);
                                    date = dateTime.ToString("yyyy-MM-ddTHH:mm:ss");
                                }
                            }

                            if (dt.Rows[row][columns].ToString().Trim().ToUpper() == "ITEM")
                            {
                                detail_row = row;
                                detail_column = columns;

                                /* Get Company Info */
                                Item companyInfo = myInnovator.applyMethod("acc_getCompanyInfo", "");
                                /** <Adding Sale Header> **/
                                saleOrderHeader = myInnovator.newItem("sop_sale_order");
                                // if soNo is not provided from excel. (quotation) - get default sequence like in Form.
                                if (soNo == "" || soNo == null)
                                {
                                    DateTime currentDate = DateTime.UtcNow.Date;
                                    var year = currentDate.Year.ToString();
                                    var shortYear = year.Substring(2);

                                    var e_prefixItem = myInnovator.newItem("Variable", "get");
                                    e_prefixItem.setAttribute("where", "[variable].name='WF_PREFIX_SALES_ORDER_EQUIPMENT'");
                                    e_prefixItem = e_prefixItem.apply();
                                    var e_prefix = e_prefixItem.getProperty("value", "");

                                    var e_sequence = myInnovator.newItem("sequence", "get");
                                    e_sequence.setProperty("name", "sop_sale_order_equipment");
                                    e_sequence = e_sequence.apply();
                                    string e_current_value = e_sequence.getProperty("current_value");
                                    int i_current_value = Int32.Parse(e_current_value) + 1;

                                    var equipment_so_no = e_prefix + shortYear + i_current_value.ToString();

                                    saleOrderHeader.setProperty("sop_order_no", equipment_so_no);
                                    soNo = equipment_so_no;
                                }

                                // if soNo is provided from excel file.
                                if (soNo != "")
                                {
                                    saleOrderHeader.setProperty("sop_order_no", soNo);
                                }
                                if (date != "" || date != null)
                                {
                                    saleOrderHeader.setProperty("sop_order_date", date);
                                }

                                if (date == "" || date == null)
                                {
                                    date = DateTime.UtcNow.Date.ToString("yyyy-MM-ddThh:mm:ss"); ;
                                    saleOrderHeader.setProperty("sop_order_date", date);
                                }
                                saleOrderHeader.setProperty("erp_company", companyInfo.getItemByIndex(0).getProperty("id"));
                                saleOrderHeader.setProperty("pop_currency", currency);
                                if (company != "" && company != null)
                                {
                                    Item itemCustomer = getCustomer(myInnovator, company);
                                    if (itemCustomer.getItemCount() > 0)
                                    {
                                        saleOrderHeader.setPropertyItem("sop_customer", itemCustomer);
                                        saleOrderHeader.setProperty("sop_customer_address", address);
                                    }

                                    // if customer name is not in customer list item, customer is added. 
                                    if (itemCustomer.getItemCount() == 0)
                                    {
                                        itemCustomer = myInnovator.newItem("customer", "add");
                                        itemCustomer.setProperty("name", company);
                                        itemCustomer = itemCustomer.apply();

                                        saleOrderHeader.setPropertyItem("sop_customer", itemCustomer);
                                        saleOrderHeader.setProperty("sop_customer_address", address);
                                    }
                                }

                                /*POP*/
                                saleOrderHeader.setProperty("sop_quote_no", quoteNo);
                                saleOrderHeader.setProperty("sop_attention", attentionTo);
                                saleOrderHeader.setProperty("customer_ref", strCustomerRef);
                                saleOrderHeader.setProperty("quote_by", quoteBy);
                                saleOrderHeader.setProperty("rev_no", revNo);

                                saleOrderHeader.setProperty("pop_currency_operator", "/");
                                saleOrderHeader.setProperty("pop_currency_rate", "1");
                                saleOrderHeader.setProperty("pop_gst_amount", "0.00");
                                saleOrderHeader.setProperty("pop_gst_percent", "7");
                                saleOrderHeader.setProperty("pop_sub_amount", "0.00");
                                saleOrderHeader.setProperty("pop_total_amount", "0.00");
                                saleOrderHeader.setProperty("pop_total_currency_amount", "0.00");

                                detail_row_loop: for (detail_row = detail_row + 1; detail_row <= rowsCount; detail_row++)
                                {
                                    old_sub_assembly_desc = sub_assembly_desc;
                                    for (detail_column = 1; detail_column < 7; detail_column++)
                                    {
                                        if (dt.Rows[detail_row][detail_column] != null && dt.Rows[detail_row][detail_column].ToString() != "")
                                        {
                                            if (dt.Rows[detail_row][detail_column].ToString().Trim().ToUpper().StartsWith("SINGAPORE WEFIC OCEAN TECHNOLOGIES PTE LTD STANDARD"))
                                            {
                                                END_OF_DETAILS = true;
                                                sgpWefic = dt.Rows[detail_row][detail_column].ToString();
                                            }
                                            if (END_OF_DETAILS != true)
                                            {
                                                existing_data_column_count++;
                                            }
                                        }
                                    }
                                    for (detail_column = 1; detail_column < 7; detail_column++)
                                    {
                                        if (dt.Rows[detail_row][detail_column] != null && dt.Rows[detail_row][detail_column].ToString() != "" && END_OF_DETAILS != true)
                                        {

                                            switch (existing_data_column_count)
                                            {
                                                case 1:
                                                    //if (details_desc_1 != "")
                                                    //{
                                                    sub_assembly_desc = dt.Rows[detail_row][detail_column].ToString();
                                                    if (item != "")
                                                    {
                                                        sub_assembly_item = Convert.ToInt32(item) + 1;
                                                    }

                                                    saleOrderSectionDetail = myInnovator.newItem("sop_sale_order_details");
                                                    saleOrderSectionDetail.setProperty("stk_sub_assembly_desc", sub_assembly_desc);
                                                    saleOrderSectionDetail.setProperty("stk_item", sub_assembly_item.ToString());
                                                    saleOrderHeader.addRelationship(saleOrderSectionDetail);
                                                    sub_assembly_item++;
                                                    //}
                                                    //if (sub_assembly_desc == "")
                                                    //{
                                                    //    details_desc_1 = dt.Rows[detail_row][detail_column].ToString();
                                                    //}
                                                    break;

                                                case 2:
                                                    sub_assembly_total_label = dt.Rows[detail_row][detail_column].ToString();
                                                    sub_assembly_total_amount = Convert.ToString(dt.Rows[detail_row][6]).Replace(",", String.Empty);

                                                    sub_assembly_qty = new String(sub_assembly_total_label.Where(Char.IsDigit).ToArray());

                                                    if (sub_assembly_desc == "")
                                                    {
                                                        count++;

                                                        switch (count)
                                                        {
                                                            case 1:
                                                                sop_total_line_1 = sub_assembly_total_label;
                                                                sop_total_line_1_value = sub_assembly_total_amount;
                                                                break;
                                                            case 2:
                                                                sop_total_line_2 = sub_assembly_total_label;
                                                                sop_total_line_2_value = sub_assembly_total_amount;
                                                                break;
                                                            case 3:
                                                                sop_total_line_3 = sub_assembly_total_label;
                                                                sop_total_line_3_value = sub_assembly_total_amount;
                                                                break;
                                                        }
                                                    }
                                                    if (sub_assembly_desc != "")
                                                    {
                                                        saleOrderSectionDetail.setProperty("stk_sub_assembly_total_label", sub_assembly_total_label);
                                                        saleOrderSectionDetail.setProperty("stk_sub_assembly_total", sub_assembly_total_amount);
                                                        saleOrderSectionDetail.setProperty("stk_sub_assembly_qty", sub_assembly_qty);
                                                        sub_assembly_desc = "";
                                                    }
                                                    existing_data_column_count = 0;
                                                    sub_assembly_total_label = "";
                                                    goto detail_row_loop;
                                                    break;

                                                case 6:
                                                    detail_column_count++;
                                                    switch (detail_column_count)
                                                    {
                                                        case 1:
                                                            item = dt.Rows[detail_row][detail_column].ToString();
                                                            break;
                                                        case 2:
                                                            qty = dt.Rows[detail_row][detail_column].ToString();
                                                            break;
                                                        case 3:
                                                            keurpn = dt.Rows[detail_row][detail_column].ToString();

                                                            if (keurpn.Length < 4 && keurpn != "-")
                                                            {
                                                                keurpn = "TBA";
                                                            }
                                                            else if (keurpn == "-")
                                                            {
                                                                keurpn = "-";
                                                            }

                                                            /* Adding Part and Stock For TBA */
                                                            string stock = getStock(myInnovator, keurpn);
                                                            if (stock == "")
                                                            {
                                                                string itemNumber = "";

                                                                /** if QuoteNo is not empty : 
                                                                    Create new Stock with item_number 'TBA-QuoteNo-LineItemNo **/
                                                                if (quoteNo != "" && quoteNo != null && keurpn != "-")
                                                                {
                                                                    itemNumber = "TBA-" + quoteNo + "-" + item;
                                                                }

                                                                /** if SO No is not empty   : 
                                                                    Create new Stock with item_number 'TBA-SO No-LineItemNo' **/
                                                                if (soNo != "" && soNo != null && keurpn != "-")
                                                                {
                                                                    itemNumber = "TBA-" + soNo + "-" + item;
                                                                }

                                                                if (keurpn == "-")
                                                                {
                                                                    itemNumber = "-" + soNo + "-" + item;
                                                                }

                                                                stock = getStock(myInnovator, itemNumber);
                                                                if (stock == "")
                                                                {
                                                                    Item addStock = this.newItem("stk_stock_setup", "add");
                                                                    addStock.setProperty("stk_code", itemNumber);
                                                                    addStock.setProperty("stk_description", description);
                                                                    addStock.setProperty("stk_price", unitprice);
                                                                    addStock = addStock.apply();

                                                                    if (addStock.isError())
                                                                    {
                                                                        return myInnovator.newResult("error : Add new Stock : " + itemNumber);
                                                                    }
                                                                }


                                                                keurpn = itemNumber;

                                                            }
                                                            /* End For TBA  */
                                                            break;
                                                        case 4:
                                                            description = dt.Rows[detail_row][detail_column].ToString();
                                                            break;
                                                        case 5:
                                                            unitprice = dt.Rows[detail_row][detail_column].ToString().Replace(",", String.Empty);
                                                            break;
                                                        case 6:
                                                            totalprice = dt.Rows[detail_row][detail_column].ToString().Replace(",", String.Empty);
                                                            if (totalprice != "" && totalprice != "-")
                                                            {
                                                                subTotal = subTotal + Convert.ToDouble(totalprice);
                                                            }

                                                            if (unitprice == "" || unitprice == "-")
                                                            {
                                                                unitprice = "0";
                                                            }
                                                            if (totalprice == "" || totalprice == "-")
                                                            {
                                                                totalprice = "0";
                                                            }
                                                            break;
                                                    }
                                                    if (detail_column_count == 6)
                                                    {
                                                        if (sub_assembly_desc == "")
                                                        {
                                                            saleOrderSectionDetail = this.newItem("sop_sale_order_details", "add");
                                                            saleOrderSectionDetail.setProperty("stk_item", item);
                                                            saleOrderSectionDetail.setProperty("stk_row_number", stk_row_number.ToString());
                                                            saleOrderSectionDetail.setProperty("stk_code", getStock(myInnovator, keurpn));
                                                            saleOrderSectionDetail.setProperty("stk_description", description);
                                                            saleOrderSectionDetail.setProperty("stk_qty", qty);
                                                            saleOrderSectionDetail.setProperty("stk_uom", getUOM(myInnovator, "uom"));
                                                            saleOrderSectionDetail.setProperty("stk_price", unitprice);
                                                            saleOrderSectionDetail.setProperty("stk_total_amount", totalprice);
                                                            saleOrderHeader.addRelationship(saleOrderSectionDetail);
                                                        }

                                                        if (sub_assembly_desc != "")
                                                        {
                                                            Item saleOrderDetail = myInnovator.newItem("sop_section_details");
                                                            saleOrderDetail.setProperty("stk_item", item);
                                                            saleOrderDetail.setProperty("stk_code", getStock(myInnovator, keurpn));
                                                            saleOrderDetail.setProperty("stk_description", description);
                                                            saleOrderDetail.setProperty("stk_qty", qty);
                                                            saleOrderDetail.setProperty("stk_uom", getUOM(myInnovator, "uom"));
                                                            saleOrderDetail.setProperty("stk_price", unitprice);
                                                            saleOrderDetail.setProperty("stk_total_amount", totalprice);

                                                            //Item sectionDetail = myInnovator.newItem("sop_section_details");
                                                            //sectionDetail.setRelatedItem(saleOrderDetail);
                                                            saleOrderSectionDetail.addRelationship(saleOrderDetail);
                                                        }

                                                        detail_column_count = 0;
                                                        //item = "";
                                                        qty = "";
                                                        keurpn = "";
                                                        description = "";
                                                        unitprice = "0";
                                                        totalprice = "0";
                                                    }
                                                    break;
                                            }
                                        }
                                    }
                                    old_existing_data_column_count = existing_data_column_count;
                                    existing_data_column_count = 0;
                                }
                            }

                            if (dt.Rows[row][columns].ToString().Trim().ToUpper().StartsWith("DRAWING NO"))
                            {
                                if (dt.Rows[row][columns + 1] != null)
                                {
                                    drawingNo = dt.Rows[row][columns + 1].ToString();
                                }
                            }

                            if (dt.Rows[row][columns].ToString().Trim().ToUpper().StartsWith("TPI REQUIRED"))
                            {
                                if (dt.Rows[row][columns] != null)
                                {
                                    tpiRequired_1 = dt.Rows[row][columns].ToString();
                                    tpiRequired = tpiRequired_1;
                                }

                                if (dt.Rows[row + 1][columns] != null)
                                {
                                    tpiRequired_2 = dt.Rows[row + 1][columns].ToString();
                                }

                                if (dt.Rows[row][columns + 1] != null)
                                {
                                    tpiRequired_3 = dt.Rows[row][columns + 1].ToString();
                                }

                            }

                            if (dt.Rows[row][columns].ToString().Trim().ToUpper().StartsWith("FAT REQUIRED"))
                            {
                                if (dt.Rows[row][columns] != null)
                                {
                                    fatRequired = dt.Rows[row][columns].ToString();
                                }
                            }


                            if (dt.Rows[row][columns].ToString().Trim().ToUpper().StartsWith("PROPOSED PAINT SPECIFICATION"))
                            {
                                if (dt.Rows[row][columns] != null)
                                {
                                    proposedPaint = dt.Rows[row][columns].ToString();
                                }
                            }



                            if (dt.Rows[row][columns].ToString().Trim().ToUpper().StartsWith("PAINT SPECIFICATION"))
                            {
                                if (dt.Rows[row][columns] != null)
                                {
                                    proposedPaint = dt.Rows[row][columns].ToString();
                                }
                            }

                            if (dt.Rows[row][columns].ToString().Trim().ToUpper().StartsWith("PRICES :"))
                            {
                                if (dt.Rows[row + 1][columns] != null)
                                {
                                    prices = dt.Rows[row + 1][columns].ToString();
                                }
                            }

                            if (dt.Rows[row][columns].ToString().Trim().ToUpper().StartsWith("DELIVERY TERM"))
                            {
                                if (dt.Rows[row + 1][columns] != null)
                                {
                                    delivery_term = dt.Rows[row + 1][columns].ToString();
                                }
                            }

                            if (dt.Rows[row][columns].ToString().Trim().ToUpper().StartsWith("DELIVERY :"))
                            {
                                if (dt.Rows[row + 1][columns].ToString().Trim().ToUpper().StartsWith("VALIDITY :"))
                                {
                                    END_OF_DELIVERY = true;
                                }
                                if (dt.Rows[row + 1][columns] != null)
                                {
                                    delivery = dt.Rows[row + 1][columns].ToString();
                                }
                            }

                            // 2018-02-01--MyoThet
                            if (dt.Rows[row][columns].ToString().Trim().ToUpper().StartsWith("DELIVERY :"))
                            {
                                if (dt.Rows[row + 2][columns] != null)
                                {
                                    if (dt.Rows[row + 2][columns].ToString().Trim().ToUpper().StartsWith("VALIDITY :"))
                                    {
                                        END_OF_DELIVERY = true;
                                    }

                                    if (!END_OF_DELIVERY)
                                    {
                                        delivery += "\n" + dt.Rows[row + 2][columns].ToString();
                                    }
                                }
                            }

                            if (dt.Rows[row][columns].ToString().Trim().ToUpper().StartsWith("DELIVERY :"))
                            {
                                if (dt.Rows[row + 3][columns] != null)
                                {
                                    if (dt.Rows[row + 3][columns].ToString().Trim().ToUpper().StartsWith("VALIDITY :"))
                                    {
                                        END_OF_DELIVERY = true;
                                    }

                                    if (!END_OF_DELIVERY)
                                    {
                                        delivery += "\n" + dt.Rows[row + 3][columns].ToString();
                                    }
                                }

                                if (dt.Rows[row][columns].ToString().Trim().ToUpper().StartsWith("DELIVERY :"))
                                {
                                    if (dt.Rows[row + 4][columns] != null)
                                    {
                                        if (dt.Rows[row + 4][columns].ToString().Trim().ToUpper().StartsWith("VALIDITY :"))
                                        {
                                            END_OF_DELIVERY = true;
                                        }

                                        if (!END_OF_DELIVERY)
                                        {
                                            delivery += "\n" + dt.Rows[row + 4][columns].ToString();
                                        }
                                    }
                                }
                            }
                        }
                    }
                }

                /** TPI Required **/
                if (Convert.ToString(tpiRequired) != "" && Convert.ToString(tpiRequired) != null)
                {
                    string[] arrtpiRequired = tpiRequired.Split(':');
                    if (arrtpiRequired.Length > 0)
                    {
                        strtpiRequired = arrtpiRequired[1];
                        strtpiRequired = strtpiRequired + tpiRequired_3 + tpiRequired_2;
                    }
                }

                /** Proposed Paint **/
                if (Convert.ToString(proposedPaint) != "" && Convert.ToString(proposedPaint) != null)
                {
                    string[] arrproposedPaint = proposedPaint.Split(':');
                    if (arrproposedPaint.Length > 0)
                    {
                        strproposedPaint = arrproposedPaint[1];
                    }
                }

                /** Fat Required **/
                if (Convert.ToString(fatRequired) != "" && Convert.ToString(fatRequired) != null)
                {
                    string[] arrFatRequired = fatRequired.Split(':');
                    if (arrFatRequired.Length > 0)
                    {
                        strFatRequired = arrFatRequired[1];
                    }
                }

                saleOrderHeader.setProperty("pop_sub_amount", subTotal.ToString());
                saleOrderHeader.setProperty("sop_total_line_1", sop_total_line_1);
                saleOrderHeader.setProperty("sop_total_line_1_value", sop_total_line_1_value);
                saleOrderHeader.setProperty("sop_total_line_2", sop_total_line_2);
                saleOrderHeader.setProperty("sop_total_line_2_value", sop_total_line_2_value);
                saleOrderHeader.setProperty("sop_total_line_3", sop_total_line_3);
                saleOrderHeader.setProperty("sop_total_line_3_value", sop_total_line_3_value);

                saleOrderHeader.setProperty("sop_wefic_terms_condtions", sgpWefic);
                saleOrderHeader.setProperty("sop_drawing_no", drawingNo);
                saleOrderHeader.setProperty("sop_fat_required", strFatRequired);
                saleOrderHeader.setProperty("sop_prices", prices);
                saleOrderHeader.setProperty("sop_delivery_term", delivery_term);
                saleOrderHeader.setProperty("sop_delivery", delivery);
                saleOrderHeader.setProperty("sop_tpi_required", strtpiRequired);
                saleOrderHeader.setProperty("sop_proposed_paint", strproposedPaint);
                saleOrderHeader.setProperty("sop_details_desc_1", details_desc_1);

                //clean up stuffs
                workbook.Close(false, Type.Missing, Type.Missing);
                Marshal.ReleaseComObject(workbook);

                result = saleOrderHeader;
            }
            catch (System.Exception ex)
            {
                result = myInnovator.newError(string.Format("SYSTEM EXCEPTION in method {0}\n{1}", MethodName, ex.Message));
                ////result.setErrorCode("0");		//only use if this method is called from another method
            }
            finally
            {
                //**** REVOKE IDENTITY PRIVILEGES
                // revokeIdentityPrivileges();
                //*******************************
            }

            return result;
        }

        private string getStock(Innovator myInnovator, string itemNumber)
        {
            string stkID = "";

            Item itemStock = myInnovator.newItem("stk_stock_setup", "get");
            itemStock.setProperty("stk_code", itemNumber.Trim());
            itemStock.setPropertyCondition("stk_code", "eq");
            itemStock = itemStock.apply();
            if (itemStock.getItemCount() > 0)
            {
                stkID = itemStock.getID();
            }
            return stkID;
        }
        private Item getCustomer(Innovator inno, string customer)
        {
            //{customerName,customerEmail,customerAddress};
            Item itmCustomer = inno.newItem("customer", "get");
            itmCustomer.setProperty("name", customer.Trim());
            itmCustomer.setPropertyCondition("name", "eq");
            itmCustomer = itmCustomer.apply();
            return itmCustomer;
        }
        private string getUOM(Innovator inno, string uom)
        {
            string uomID = "";
            Item itmUom = inno.newItem("stk_uom", "get");
            itmUom = itmUom.apply();
            uomID = itmUom.getItemByIndex(0).getID();
            return uomID;
        }

        public static string CheckOutFile(Innovator inno, string fileID, string checkOutDirector, string fileName)
        {
            string FileDirectory = Path.Combine(checkOutDirector, fileName);
            try
            {
                if (File.Exists(FileDirectory))
                {

                    File.Delete(FileDirectory);

                }
                Item get_file_request = inno.newItem();
                get_file_request.setType("File");
                get_file_request.setAction("get");
                get_file_request.setID(fileID);
                Item fileItem = get_file_request.apply();
                Item checkoutResult = fileItem.checkout(checkOutDirector);
                if (checkoutResult.isError())
                    throw new Exception(string.Format("Failed to check-out file with ID={0}: {1}", fileID));
            }
            catch
            {

            }
            return FileDirectory;
        }
        /// <summary>
        /// This section is to allow the current method to assume the privileges of a specific identity.
        /// For instance calling: grantIdentityPrivileges("Aras PLM"); will allow this method all of the
        /// rights of the Aras PLM identity.
        /// The revokeIdentityPrivileges() method will removed the privileges added for this method. It
        /// must be called from before the method exits. Most likely in the Finally of the main method code.
        /// If different identity privileges must be granted a second time within the same method, first use
        /// revokeIdentityPrivileges() to remove the first privileges before granting new ones.
        /// </summary>

        private string AssignedIdentity;

        /// <summary>
        /// If required, call this helper function to run this method as another Identity. 
        /// Ensure that you call the revokeIdentityPrivileges helper function in the 
        /// finally block to revoke the Identity privilege when this method completes.
        /// </summary>
        public void grantIdentityPrivileges(string assignedIdent)
        {
            if (!string.IsNullOrEmpty(AssignedIdentity))
            {
                revokeIdentityPrivileges();
            }

            Aras.Server.Security.Identity secIdentity = Aras.Server.Security.Identity.GetByName(assignedIdent);
            if (Aras.Server.Security.Permissions.GrantIdentity(secIdentity))
            {
                AssignedIdentity = assignedIdent;
            }
        }

        /// <summary>
        /// If you granted security privileges, then you need to ensure that you revoke the privilege.
        /// </summary>
        public void revokeIdentityPrivileges()
        {
            if (AssignedIdentity != null)
            {
                Aras.Server.Security.Permissions.RevokeIdentity(Aras.Server.Security.Identity.GetByName(AssignedIdentity));
                AssignedIdentity = null;
            }]]></method_code>
  <method_type>C#</method_type>
  <name>sop_Import_SaleOrderExcel</name>
 </Item>
</AML>